## cloud-init 25.2

=== debian/changelog ===
cloud-init (25.2-0ubuntu1~24.04.1) noble; urgency=medium

  * add d/p/strip-invalid-mtu.patch
    - Provides backwards compatibility for an otherwise invalid
      MTU in a netplan config. (GH-6239)
  * d/cloud-init.templates:
    - Move VMware before OVF. See GH-4030
    - Enable CloudCIX by default
  * refresh patches:
    - d/p/no-single-process.patch
  * Upstream snapshot based on 25.2. (LP: #2120495).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.2/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 12 Aug 2025 16:19:32 -0500

cloud-init (25.1.4-0ubuntu0~24.04.1) noble-security; urgency=medium

  * Upstream snapshot based on 25.1.4.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.1.4/ChangeLog
    - Bugs fixed in this snapshot:
      + fix: disable cloud-init when non-x86 environments have no DMI-data
        and no strict datasources detected (LP: #2069607) (CVE-2024-6174)

 -- Chad Smith <chad.smith@canonical.com>  Tue, 24 Jun 2025 15:14:03 -0600

cloud-init (25.1.3-0ubuntu0~24.04.1) noble-security; urgency=medium

  * d/cloud-init-base.postinst: move existing hotplug-cmd fifo to root-only
    share dir (CVE-2024-11584)
  * Upstream security bugfix release based on 25.1.3.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.1.3/ChangeLog
    - Bugs fixed in this snapshot:
    - security: make hotplug socket only writable by root (LP: #2114229)
      (CVE-2024-11584)
    - security: make ds-identify behavior strict datasource discovery on
      non-x86 platforms without DMI data (LP: #2069607) (CVE-2024-6174)

 -- Chad Smith <chad.smith@canonical.com>  Thu, 12 Jun 2025 20:24:45 -0600

cloud-init (25.1.2-0ubuntu0~24.04.1) noble; urgency=medium

  * Upstream snapshot based on 25.1.2. (LP: #2104165).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.1.2/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Mon, 19 May 2025 15:00:58 -0500

cloud-init (25.1.1-0ubuntu1~24.04.1) noble; urgency=medium

  * Drop cpicks which are now upstream:
    - cpick-d75840be-fix-retry-AWS-hotplug-for-async-IMDS-5995
    - cpick-84806336-chore-Add-feature-flag-for-manual-network-waiting
    - d/p/cpick-c60771d8-test-pytestify-test_url_helper.py
    - d/p/cpick-8810a2dc-test-Remove-CiTestCase-from-test_url_helper.py
    - d/p/cpick-582f16c1-test-add-OauthUrlHelper-tests
    - d/p/cpick-9311e066-fix-Update-OauthUrlHelper-to-use-readurl-exception_cb
  * refresh patches
    - d/p/deprecation-version-boundary.patch
    - d/p/grub-dpkg-support.patch
    - d/p/no-nocloud-network.patch
    - d/p/no-single-process.patch
  * sort hunks within all patches (--sort on quilt refresh)
  * Upstream snapshot based on 25.1.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.1.1/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Tue, 25 Mar 2025 11:02:28 -0600

cloud-init (24.4.1-0ubuntu0~24.04.3) noble; urgency=medium

  * d/control: Fix how cloud-init-base overwrites cloud-init files.
    (LP: #2092333)

 -- James Falcon <james.falcon@canonical.com>  Wed, 02 Apr 2025 10:09:15 -0500

cloud-init (24.4.1-0ubuntu0~20.04.2) noble; urgency=medium

  * cherry-pick fixes for MAAS traceback (LP: #2100963)
    - cherry-pick c60771d8: test: pytestify test_url_helper.py
    - cherry-pick 8810a2dc: test: Remove CiTestCase from
      test_url_helper.py
    - cherry-pick 582f16c1: test: add OauthUrlHelper tests
    - cherry-pick 9311e066: fix: Update OauthUrlHelper to use readurl
      exception_cb

 -- James Falcon <james.falcon@canonical.com>  Thu, 13 Mar 2025 11:28:57 -0500

cloud-init (24.4.1-0ubuntu0~24.04.1) noble; urgency=medium

  * Add d/p/cpick-84806336-chore-Add-feature-flag-for-manual-network-waiting
    - Pull in the upstream commit that makes it easier to patch out the
      new systemd-networkd-wait-online behavior in e30549e8
  * Add d/p/cpick-b817a679-fix-retry-AWS-hotplug-for-async-IMDS.patch
    - Pull in the upstream commit works around a limitation in AWS's IMDS
      (GH-5971) (LP: #2097319)
  * Add d/p/no-remove-networkd-online.patch
    - Revert breaking change on stable release (LP: #2094149)
  * Update d/p/no-single-process.patch
    - This patch missed waiting for mounts (LP: #2097441)
  * Upstream snapshot based on 24.4.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.4.1/ChangeLog
    (LP: #2094179, #2094208, #2094857, #2094858)

 -- Brett Holman <brett.holman@canonical.com>  Tue, 04 Feb 2025 15:36:06 -0700

cloud-init (24.4-0ubuntu1~24.04.2) noble; urgency=medium

  * Fix d/p/no-single-process.patch
    - It didn't contain removal of cloud-init-network.service nor
      the removal of the network.service reference

 -- James Falcon <james.falcon@canonical.com>  Mon, 02 Dec 2024 13:09:22 -0600

cloud-init (24.4-0ubuntu1~24.04.1) noble; urgency=medium

  * add d/p/grub-dpkg-support.patch
    - Revert the removal of grub-dpkg from default modules
  * refresh patches:
    - d/p/deprecation-version-boundary.patch
    - d/p/no-nocloud-network.patch
    - d/p/no-single-process.patch
  * Upstream snapshot based on 24.4. (LP: #2089577).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.4/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 26 Nov 2024 07:46:41 -0600

cloud-init (24.3.1-0ubuntu0~24.04.1) noble; urgency=medium

  * d/p/no-single-process.patch: Remove single process optimization
  * d/p/no-nocloud-network.patch: Remove nocloud network feature
  * Upstream snapshot based on upstream/main at acf04d61.
  * Upstream snapshot based on 24.3.1. (LP: #2079224).
    List of changes from upstream can be found at


=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               iproute2,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses,
               python3-passlib
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         dhcpcd-base,
         iproute2,
         netplan.io,
         procps,
         python3,
         python3-debconf,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, gnupg, python3-apt, software-properties-common
Suggests: openssh-server, ssh-import-id
Breaks: python3-minimal (<< 3.12.3-0ubuntu2~)
Provides: cloud-init-base
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

INIT_SYSTEM ?= systemd
export PYBUILD_INSTALL_ARGS=--init-system=$(INIT_SYSTEM)

%:
	dh $@ --with python3 --buildsystem pybuild

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	http_proxy= make PYVER=python3 check
else
	@echo check disabled by DEB_BUILD_OPTIONS=$(DEB_BUILD_OPTIONS)
endif

override_dh_installsystemd:
	dh_installsystemd --no-restart-on-upgrade --no-start

override_dh_auto_install:
	dh_auto_install --destdir=debian/cloud-init
	install -D -m 0644 ./tools/21-cloudinit.conf debian/cloud-init/etc/rsyslog.d/21-cloudinit.conf
	install -D ./tools/Z99-cloud-locale-test.sh debian/cloud-init/etc/profile.d/Z99-cloud-locale-test.sh
	install -D ./tools/Z99-cloudinit-warnings.sh debian/cloud-init/etc/profile.d/Z99-cloudinit-warnings.sh
	install -m 0644 -D debian/apport-general-hook.py debian/cloud-init/usr/share/apport/general-hooks/cloud-init.py
	install -m 0644 -D debian/apport-launcher.py debian/cloud-init/usr/share/apport/package-hooks/cloud-init.py
	flist=$$(find $(CURDIR)/debian/ -type f -name version.py) && sed -i 's,@@PACKAGED_VERSION@@,$(DEB_VERSION),' $${flist:-did-not-find-version-py-for-replacement}

## cloud-init 25.3~1g890873f5

=== debian/changelog ===
cloud-init (25.3~1g890873f5-0ubuntu1) questing; urgency=medium

  * d/control:
    - ensure binary packages depend on same version of cloud-init-base.
    - update build-dependencies to support meson instead of setuptools
      (LP: #1978328) (GH-5027)
  * d/rules:
    - use meson build backend instead of pybuild setuptools
      (LP: #1978328) (GH-5027)
  * Upstream snapshot based on upstream/main at 890873f5.
    - Bugs fixed in this snapshot: (LP: #1978328)

 -- Chad Smith <chad.smith@canonical.com>  Fri, 22 Aug 2025 22:07:56 -0600

cloud-init (25.2-0ubuntu1) questing; urgency=medium

  * Upstream snapshot based on 25.2.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.2/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 12 Aug 2025 14:11:35 -0500

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,9 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper-compat (= 13),
                dh-python,
+               meson,
+               pkgconf,
+               bash-completion,
                iproute2,
                po-debconf,
                python3,
@@ -19,32 +22,70 @@
                python3-pytest-mock,
                python3-requests,
                python3-serial,
-               python3-setuptools,
                python3-yaml,
                python3-responses,
-               python3-passlib
+               python3-passlib,
+               udev,
+               systemd-dev
 Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
 Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 
-Package: cloud-init
+Package: cloud-init-base
 Architecture: all
 Depends: cloud-guest-utils | cloud-utils,
          dhcpcd-base,
          iproute2,
+         netcat-openbsd,
          netplan.io,
          procps,
          python3,
          python3-debconf,
          python3-requests,
-         python3-serial,
          ${misc:Depends},
          ${python3:Depends}
 Recommends: eatmydata, gdisk, gnupg, python3-apt, software-properties-common
 Suggests: openssh-server, ssh-import-id
-Breaks: python3-minimal (<< 3.12.3-0ubuntu2~)
-Provides: cloud-init-base
+Replaces: cloud-init (<< 25.1.1-0ubuntu2~), cloud-init-base
+Breaks: cloud-init (<< 25.1.1-0ubuntu2~), cloud-init-base
+Description: initialization and customization tool for cloud instances
+ Cloud-init with minimal dependencies, refer to cloud-init for more
+ information.
+
+Package: cloud-init-azure
+Architecture: all
+Depends: cloud-init-base (= ${binary:Version}),
+         python3-passlib,
+         ${misc:Depends},
+Description: Azure specific cloud-init
+ This metapackage depends on cloud-init-base and additional packages for
+ Azure.
+
+Package: cloud-init-cloud-sigma
+Architecture: all
+Depends: cloud-init-base (= ${binary:Version}),
+         python3-serial,
+         ${misc:Depends},
+Description: Cloud Sigma specific cloud-init
+ This metapackage depends on cloud-init-base and additional packages for
+ Cloud Sigma.
+
+Package: cloud-init-smart-os
+Architecture: all
+Depends: cloud-init-base (= ${binary:Version}),
+         python3-serial,
+         ${misc:Depends},
+Description: Smart OS specific cloud-init
+ This metapackage depends on cloud-init-base and additional packages for
+ Smart OS.
+
+Package: cloud-init
+Architecture: all
+Depends: cloud-init-base (= ${binary:Version}),
+         python3-serial,
+         python3-passlib,
+         ${misc:Depends},
 Description: initialization and customization tool for cloud instances
  Cloud-init is the industry standard multi-distribution method for
  cross-platform cloud instance initialization. It is supported across all major
@@ -63,3 +104,5 @@
  access key and many other aspects of a system. Later on the cloud-init will
  also parse and process any optional user or vendor data that was passed to
  the instance.
+ .
+ This is a metapackage that includes every cloud-init dependency.

## cloud-init 25.3~2g890873f5

=== meson_options.txt ===
option('init_system', type: 'string', value: 'systemd', description: 'Set target init system.')
option('distro_templates', type: 'array', value: [], description: 'Distro template files to install. WARNING: Templates may change in the future. If using this option, be sure to check new releases for template file changes.')
option('disable_sshd_keygen', type: 'boolean', value: false, description: 'Provide systemd service to disable sshd-keygen if present to avoid races with cloud-init.')

=== debian/changelog ===
cloud-init (25.3~2g890873f5-0ubuntu3) questing; urgency=medium

  * d/cloud-init-base.config: update migrate_debconf_settings to
    set an empty cloud-init/datasources value once it migrates the value to
    cloud-init-base/datasources. (LP: #2127022)
  * d/cloud-init-base.postinst: fix release upgrade affecting the set of
    multi-line debconf value cloud-init/local-cloud-config used by MAAS.
    (LP: #2127022)

 -- Chad Smith <chad.smith@canonical.com>  Mon, 27 Oct 2025 13:48:39 -0600

cloud-init (25.3~2g890873f5-0ubuntu2) questing; urgency=medium

  * d/control: add all missing python3 package runtime deps (LP: #2121482)

 -- Chad Smith <chad.smith@canonical.com>  Wed, 27 Aug 2025 15:15:40 -0600

cloud-init (25.3~2g890873f5-0ubuntu1) questing; urgency=medium

  * d/control: add jinja2 and jsonpatch dependencies (LP: #2121482)

 -- Brett Holman <brett.holman@canonical.com>  Wed, 27 Aug 2025 09:01:05 -0600

## cloud-init 25.3

=== Makefile ===
CWD=$(shell pwd)
VARIANT ?= ubuntu

PYTHON ?= python3

NUM_ITER ?= 100

distro ?= redhat

READ_VERSION=$(shell $(PYTHON) $(CWD)/tools/read-version || echo read-version-failed)
CODE_VERSION=$(shell $(PYTHON) -c "from cloudinit import version; print(version.version_string())")
GENERATOR_F=./systemd/cloud-init-generator
DS_IDENTIFY=./tools/ds-identify
BENCHMARK=./tools/benchmark.sh


all: check

check: check_version test

style-check: lint

lint:
	@$(CWD)/tools/run-lint

unittest: clean_pyc
	$(PYTHON) -m pytest -v tests/unittests cloudinit

render-template:
	$(PYTHON) ./tools/render-template --variant=$(VARIANT) $(FILE) $(subst .tmpl,,$(FILE))

# from systemd-generator(7) regarding generators:
# "We do recommend C code however, since generators are executed
# synchronously and hence delay the entire boot if they are slow."
#
# Our generator is a shell script. Make it easy to measure the
# generator. This should be monitored for performance regressions
benchmark-generator: FILE=$(GENERATOR_F).tmpl
benchmark-generator: VARIANT="benchmark"
benchmark-generator: export ITER=$(NUM_ITER)
benchmark-generator: render-template
	$(BENCHMARK) $(GENERATOR_F)

benchmark-ds-identify: export ITER=$(NUM_ITER)
benchmark-ds-identify:
	$(BENCHMARK) $(DS_IDENTIFY)

ci-deps-ubuntu:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro ubuntu --test-distro

ci-deps-centos:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro centos --test-distro

test: unittest

check_version:
	@if [ "$(READ_VERSION)" != "$(CODE_VERSION)" ]; then \
		echo "Error: read-version version '$(READ_VERSION)'" \
			"not equal to code version '$(CODE_VERSION)'"; \
		exit 2; \
	else true; fi

config/cloud.cfg:
	$(PYTHON) ./tools/render-template --is-yaml config/cloud.cfg.tmpl config/cloud.cfg

clean_pyc:
	@find . -type f -name "*.pyc" -delete
	@find . -type d -name __pycache__ -delete

clean_pytest:
	rm -rf .cache htmlcov

clean_packaging:
	rm -rf srpm cloud_init.egg-info/ \
		cloud-init-*.tar.gz \
		cloud-init-*.tar.gz.asc \
		cloud-init.dsc \
		cloud-init_*.build \
		cloud-init_*.buildinfo \
		cloud-init_*.changes \
		cloud-init_*.deb \
		cloud-init_*.dsc \
		cloud-init_*.orig.tar.gz \
		cloud-init_*.tar.xz \
		cloud-init_*.upload

clean_release:
	rm -rf new-upstream-changes.txt commit.msg

clean: clean_pyc clean_pytest clean_packaging clean_release
	rm -rf doc/rtd_html .tox .coverage tags $(GENERATOR_F)

rpm:
	$(PYTHON) ./packages/brpm --distro=$(distro)

srpm:
	$(PYTHON) ./packages/brpm --srpm --distro=$(distro)

deb:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }

	$(PYTHON) ./packages/bddeb

deb-src:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }
	$(PYTHON) ./packages/bddeb -S -d

doc:
	tox -e doc

fmt:
	tox -e do_format && tox -e check_format

fmt-tip:
	tox -e do_format_tip && tox -e check_format_tip


.PHONY: all check test lint clean rpm srpm deb deb-src
.PHONY: check_version clean_pyc
.PHONY: unittest style-check render-template benchmark-generator
.PHONY: clean_pytest clean_packaging clean_release doc

=== requirements.txt ===
# Pypi requirements for cloud-init to work

# Used for untemplating any files or strings with parameters.
jinja2

# This one is currently only used by the MAAS datasource and the Event
# reporting feature when configured to use webhooks.
oauthlib

# This is only needed for places where we need to support configs in a manner
# that the built-in config parser is not sufficient (ie
# when we need to preserve comments, or do not have a top-level
# section)...
configobj>=5.0.2

# All new style configurations are in the yaml format
pyyaml

# Requests handles ssl correctly!
requests

# For patching pieces of cloud-config together
jsonpatch

# For validating cloud-config sections per schema definitions
jsonschema

=== debian/changelog ===
cloud-init (25.3-1) unstable; urgency=medium

  * New upstream version 25.3
  * refresh patches
  * switch to meson build system per upstream changes

 -- Noah Meyerhans <noahm@debian.org>  Thu, 16 Oct 2025 09:07:21 -0400

cloud-init (25.2-1) unstable; urgency=medium

  * New upstream version 25.2
  * refresh patches
  * Migrate debian-specific TestAptSourceConfigMirrorlists to pytest

 -- Noah Meyerhans <noahm@debian.org>  Tue, 19 Aug 2025 15:13:39 -0400

=== debian/control ===
Source: cloud-init
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders:
 Bastian Blank <waldi@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Noah Meyerhans <noahm@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 bash-completion,
 cmake,
 debhelper-compat (= 13),
 dh-python,
 iproute2,
 meson,
 passwd,
 po-debconf,
 procps <!nocheck>,
 pkgconf,
 pybuild-plugin-pyproject,
 pylint,
 python3-all,
 python3-pycodestyle,
 python3-setuptools,
 systemd-dev | systemd,
Build-Depends-Indep:
 python3-configobj,
 python3-httpretty (>= 0.9.5),
 python3-jinja2,
 python3-jsonpatch,
 python3-jsonschema,
 python3-netifaces,
 python3-oauthlib,
 python3-passlib,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-mock,
 python3-requests,
 python3-responses,
 python3-serial,
 python3-yaml,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-init
Vcs-Git: https://salsa.debian.org/cloud-team/cloud-init.git
Homepage: https://launchpad.net/cloud-init

Package: cloud-init
Architecture: all
Conflicts: firewalld, cloud-init-22.4.2
Replaces: cloud-init-22.4.2
Depends:
 eject,
 fdisk | util-linux (<< 2.29.2-3~),
 gdisk,
 dhcpcd-base | udhcpc | isc-dhcp-client,
 locales,
 lsb-release,
 netcat-openbsd,
 procps,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cloud-guest-utils,
 eatmydata,
 sudo,
Suggests:
 btrfs-progs,
 e2fsprogs,
 python3-passlib,
 xfsprogs,
Description: initialization system for infrastructure cloud instances
 Cloud-init provides a framework and tool to configure and customize virtual
 machine instances for Infrastructure-as-a-Service (IaaS) clouds platforms. It
 can for example set a default locale and hostname, generate SSH private host
 keys, install SSH public keys for logging into a default account, set up
 ephemeral mount points, and run user-provided scripts.
 .
 Various methods are supported for passing data to the instance at launch
 time, including the standard interfaces of multiple platforms.

=== debian/rules ===
#!/usr/bin/make -f

PYTHON3S:=$(shell py3versions -vr)
export PYBUILD_INSTALL_ARGS=--init-system=systemd,sysvinit_deb

%:
	dh $@ --with python3 --buildsystem meson

override_dh_auto_test:
	set -e && set -x && for pyvers in $(PYTHON3S); do \
		PYMAJOR=`echo $$pyvers | cut -d'.' -f1` ; \
		echo "===> Testing with python$$pyvers (python$$PYMAJOR)" ; \
		PYTHON=python$$pyvers PYTHONPATH=. python$$pyvers -m pytest -v tests/unittests --ignore-glob $(CURDIR)/tests/unittests/test_datasource/test_opennebula.py ; \
	done

execute_before_dh_auto_install:
	for f in sysvinit/debian/*; do \
	  echo $$(basename $$f); \
	  install "$$f" "debian/$$(basename $$f).init"; \
	done

override_dh_installinit:
	dh_installinit --no-start --no-stop-on-upgrade --name cloud-init-main
	dh_installinit --no-start --no-stop-on-upgrade --name cloud-init-local
	dh_installinit --no-start --no-stop-on-upgrade --name cloud-config
	dh_installinit --no-start --no-stop-on-upgrade --name cloud-final

override_dh_installsystemd:
	dh_installsystemd --no-restart-on-upgrade --no-start

override_dh_auto_clean:
	rm -rf .pybuild .pytest_cache build obj-* debian/*.init

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/canonical/cloud-init/tags \
    (?:.*?/)?v?[-_]?(\d[\-+\.:\~\d]*)@ARCHIVE_EXT@

## cloud-init 25.4~1gcb12e00e

=== meson_options.txt ===
option('init_system', type: 'string', value: 'systemd', description: 'Set target init system.')
option('distro_templates', type: 'array', value: [], description: 'Distro template files to install. WARNING: Templates may change in the future. If using this option, be sure to check new releases for template file changes.')
option('disable_sshd_keygen', type: 'boolean', value: false, description: 'Provide systemd service to disable sshd-keygen if present to avoid races with cloud-init.')
option('bash_completion', type: 'boolean', value: true, description: 'Bash completion for cloud-init.')

=== debian/changelog ===
cloud-init (25.4~1gcb12e00e-0ubuntu1) resolute; urgency=medium

  * d/cloud-init-base.config: update migrate_debconf_settings to
    set an empty cloud-init/datasources value once it migrates the value to
    cloud-init-base/datasources. (LP: #2127022)
  * d/cloud-init-base.postinst: fix release upgrade affecting the set of
    multi-line debconf value cloud-init/local-cloud-config used by MAAS.
    (LP: #2127022)

 -- Chad Smith <chad.smith@canonical.com>  Fri, 10 Oct 2025 16:58:05 -0600

cloud-init (25.3-0ubuntu1) resolute; urgency=medium

  * Upstream snapshot based on 25.3.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/25.3/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Mon, 29 Sep 2025 11:41:39 +0200

ec2-init (0.4.999-0ubuntu3) karmic; urgency=l

=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               meson,
               pkgconf,
               bash-completion,
               iproute2,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-yaml,
               python3-responses,
               python3-passlib,
               udev,
               systemd-dev
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: cloud-init-base
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         dhcpcd-base,
         iproute2,
         netcat-openbsd,
         netplan.io,
         procps,
         python3,
         python3-configobj,
         python3-debconf,
         python3-requests,
         python3-jinja2,
         python3-jsonpatch,
         python3-jsonschema,
         python3-oauthlib,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, gnupg, python3-apt, software-properties-common
Suggests: openssh-server, ssh-import-id
Replaces: cloud-init (<< 25.1.1-0ubuntu2~), cloud-init-base
Breaks: cloud-init (<< 25.1.1-0ubuntu2~), cloud-init-base
Description: initialization and customization tool for cloud instances
 Cloud-init with minimal dependencies, refer to cloud-init for more
 information.

Package: cloud-init-azure
Architecture: all
Depends: cloud-init-base (= ${binary:Version}),
         python3-passlib,
         ${misc:Depends},
Description: Azure specific cloud-init
 This metapackage depends on cloud-init-base and additional packages for
 Azure.

Package: cloud-init-cloud-sigma
Architecture: all
Depends: cloud-init-base (= ${binary:Version}),
         python3-serial,
         ${misc:Depends},
Description: Cloud Sigma specific cloud-init
 This metapackage depends on cloud-init-base and additional packages for
 Cloud Sigma.

Package: cloud-init-smart-os
Architecture: all
Depends: cloud-init-base (= ${binary:Version}),
         python3-serial,
         ${misc:Depends},
Description: Smart OS specific cloud-init
 This metapackage depends on cloud-init-base and additional packages for
 Smart OS.

Package: cloud-init
Architecture: all
Depends: cloud-init-base (= ${binary:Version}),
         python3-serial,
         python3-passlib,
         ${misc:Depends},
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.
 .
 This is a metapackage that includes every cloud-init dependency.

## cloud-init 25.4~2gb117d244

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 all: check
 
-check: check_version test
+check: test
 
 style-check: lint
 
@@ -119,7 +119,6 @@
 	tox -e do_format_tip && tox -e check_format_tip
 
 
-.PHONY: all check test lint clean rpm srpm deb deb-src
-.PHONY: check_version clean_pyc
+.PHONY: all check test lint clean rpm srpm deb deb-src clean_pyc
 .PHONY: unittest style-check render-template benchmark-generator
 .PHONY: clean_pytest clean_packaging clean_release doc

=== meson_options.txt ===
option('init_system', type: 'combo', value: 'systemd', choices: ['systemd', 'sysvinit_openrc', 'sysvinit_freebsd'], description: 'Set target init system.')
option('distro_templates', type: 'array', value: [], description: 'Distro template files to install. WARNING: Templates may change in the future. If using this option, be sure to check new releases for template file changes.')
option('disable_sshd_keygen', type: 'boolean', value: false, description: 'Provide systemd service to disable sshd-keygen if present to avoid races with cloud-init.')
option('bash_completion', type: 'boolean', value: true, description: 'Bash completion for cloud-init.')
option('downstream_version', type: 'string', value: '@DOWNSTREAM_VERSION@', description: 'Optional downstream package version if different than upstream release. Used by packagers')

=== debian/changelog ===
cloud-init (25.4~2gb117d244-0ubuntu1) resolute; urgency=medium

  * d/tests: exercise cloud-init status
  * d/cloud-init-base.config - Remove old unnecessary logic.
  * d/cloud-init-base.postinst - Remove old unnecessary logic.
  * d/cloud-init-base.preinst - Delete file, logic was obsolete.
  * d/cloud-init-base.prerm - Delete file, logic was obsolete.
  * Upstream snapshot based on upstream/main at b117d244.
    - Bugs fixed in this snapshot: (LP: #2136198)

 -- Chad Smith <chad.smith@canonical.com>  Thu, 18 Dec 2025 17:07:20 -0700

cloud-init (25.4~1gcb12e00e-0ubuntu2) resolute; urgency=medium

  * d/cloud-init-base.config and d/cloud-init-base.postinst:
    - fix debconf value migration error resulting in invalid config created
      by debian script (LP: #2131809)
    - address shellcheck failures

 -- Chad Smith <chad.smith@canonical.com>  Wed, 03 Dec 2025 14:48:59 -0700

## cloud-init 25.4~3g78f6f15e

=== debian/changelog ===
cloud-init (25.4~3g78f6f15e-0ubuntu1) resolute; urgency=medium

  * Upstream snapshot based on upstream/main at 78f6f15e.

 -- Chad Smith <chad.smith@canonical.com>  Fri, 23 Jan 2026 15:41:19 -0700

## cloud-init 25.4~4g26c7d38d

=== Makefile ===
--- 
+++ 
@@ -7,8 +7,6 @@
 
 distro ?= redhat
 
-READ_VERSION=$(shell $(PYTHON) $(CWD)/tools/read-version || echo read-version-failed)
-CODE_VERSION=$(shell $(PYTHON) -c "from cloudinit import version; print(version.version_string())")
 GENERATOR_F=./systemd/cloud-init-generator
 DS_IDENTIFY=./tools/ds-identify
 BENCHMARK=./tools/benchmark.sh
@@ -52,13 +50,6 @@
 	@$(PYTHON) $(CWD)/tools/read-dependencies --distro centos --test-distro
 
 test: unittest
-
-check_version:
-	@if [ "$(READ_VERSION)" != "$(CODE_VERSION)" ]; then \
-		echo "Error: read-version version '$(READ_VERSION)'" \
-			"not equal to code version '$(CODE_VERSION)'"; \
-		exit 2; \
-	else true; fi
 
 config/cloud.cfg:
 	$(PYTHON) ./tools/render-template --is-yaml config/cloud.cfg.tmpl config/cloud.cfg

=== debian/changelog ===
cloud-init (25.4~4g26c7d38d-0ubuntu1) resolute; urgency=medium

  * Upstream snapshot based on upstream/main at 26c7d38d.

 -- Chad Smith <chad.smith@canonical.com>  Fri, 30 Jan 2026 18:40:15 -0700

cloud-init (25.4~3g78f6f15e-0ubuntu2) resolute; urgency=medium

  * d/rules: set meson downstream_version option to DEB_VERSION

 -- Chad Smith <chad.smith@canonical.com>  Sat, 24 Jan 2026 22:02:35 -0700

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with python3 --buildsystem meson

override_dh_auto_configure:
	dh_auto_configure -- -Dinit_system=systemd -Dlibexecdir=lib -Ddistro_templates=chef_client.rb.tmpl,chrony.conf.ubuntu.tmpl,hosts.debian.tmpl,ntp.conf.ubuntu.tmpl,sources.list.ubuntu.deb822.tmpl,sources.list.ubuntu.deb822.tmpl,timesyncd.conf.tmpl -Ddownstream_version=$(DEB_VERSION)

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	http_proxy= make PYVER=python3 check
else
	@echo check disabled by DEB_BUILD_OPTIONS=$(DEB_BUILD_OPTIONS)
endif

override_dh_installsystemd:
	dh_installsystemd --no-restart-on-upgrade --no-start

override_dh_auto_install:
	dh_auto_install --destdir=debian/cloud-init-base
	install -D -m 0644 ./tools/21-cloudinit.conf debian/cloud-init-base/etc/rsyslog.d/21-cloudinit.conf
	install -D ./tools/Z99-cloud-locale-test.sh debian/cloud-init-base/etc/profile.d/Z99-cloud-locale-test.sh
	install -D ./tools/Z99-cloudinit-warnings.sh debian/cloud-init-base/etc/profile.d/Z99-cloudinit-warnings.sh
	install -m 0644 -D debian/apport-general-hook.py debian/cloud-init-base/usr/share/apport/general-hooks/cloud-init.py
	install -m 0644 -D debian/apport-launcher.py debian/cloud-init-base/usr/share/apport/package-hooks/cloud-init.py

=== debian/tests/control ===
Tests: commandline_status.sh
Restrictions: needs-root, needs-reboot, breaks-testbed

## cloud-init 26.1

=== requirements.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # that the built-in config parser is not sufficient (ie
 # when we need to preserve comments, or do not have a top-level
 # section)...
-configobj>=5.0.2
+configobj
 
 # All new style configurations are in the yaml format
 pyyaml

=== debian/changelog ===
cloud-init (26.1-0ubuntu1) resolute; urgency=medium

  * Upstream snapshot based on 26.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/26.1/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Fri, 27 Feb 2026 19:10:12 -0700
